\\ Copyright 2015, 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.



geom_inertia__z_is_first_quadrant(z) = geom_point_x(z)>=0 && geom_point_y(z)>=0;

geom_inertia_wedge_in_one(z1,z2) =
{
  \\ print("geom_inertia_wedge_in_one_apply");
  \\ print("  z1 = "z1);
  \\ print("  z2 = "z2);
  \\ if(arg(z2) < arg(z1),
  \\    error("geom_inertia_wedge_in_one_apply() z1,z2 not anti-clockwise: "z1"  "z2));

  my(mul=1);
  if(geom_point_y(z1)<0 || geom_point_y(z2)<0,
     z1=conj(z1); z2=conj(z2);
     mul *= -1;
     [z1,z2]=[z2,z1];
     \\ print("  conjugate to "z1"  "z2);
     );
  if(geom_point_x(z1)<0 || geom_point_x(z2)<0,
     z1=-conj(z1); z2=-conj(z2);
     mul *= -1;
     [z1,z2]=[z2,z1];
     \\ print("  conj real to "z1"  "z2);
     );

  my(m = geom_inertia_of_triangle(z1,z2));
  m[1,2] *= mul;
  m[2,1] *= mul;
  m;
}

geom_inertia__polygon_split_into_quadrants(v) =
{
  my(l = List([]));
  for(i=1,#v,
     my(z1 = v[i],
        z2 = v[(i%#v) + 1]);
     listput(l, z1);
     if(geom_point_y(z1)*geom_point_y(z2) < 0,
        listput(l, geom_inertia__complex_X_intercept(z1,z2)));
  );
  v = Vec(l);
  
  l = List([]);
  for(i=1,#v,
     my(z1 = v[i],
        z2 = v[(i%#v) + 1]);
     listput(l, z1);
     if(geom_point_x(z1)*geom_point_x(z2) < 0,
        listput(l, I*geom_inertia__complex_Y_intercept(z1,z2)));
  );
  Vec(l);
}


geom_inertia__print(m) =
{
  print("  Ix = ", geom_inertia_Ix(m));
  print("  Iy = ", geom_inertia_Iy(m));
  print("  Ixy = ", geom_inertia_Ixy(m));
}



geom_inertia_arctan_z(M) = \
  (geom_inertia_Ix(M) - geom_inertia_Iy(M))/2   - geom_inertia_Ixy(M)*I;

geom_inertia_arctan_fraction(M) =
{
  my(z = geom_inertia_arctan_z(M));
  geom_point_y(z) / geom_point_x(z);
}

geom_inertia_principal_2fraction(M) = \
  my(p=geom_inertia_principal_2xydir(M)); geom_point_y(p)/geom_point_x(p);

geom_inertia_principal_minimum(M) = geom_inertia_principal_maximum(M) + Pi/2;

